package com.jiuqi.syntax;

import java.util.ArrayList;
import java.util.HashMap;

public final class Functions extends ArrayList {
   private HashMap hashFunctions = new HashMap();

   public Function getFunc(int index) {
      return (Function)super.get(index);
   }

   public Function getFunc(String name) {
      return (Function)this.hashFunctions.get(name.toUpperCase());
   }

   public boolean exists(String name) {
      return this.hashFunctions.get(name.toUpperCase()) != null;
   }

   public boolean add(Object obj) {
      boolean b = super.add(obj);
      if (b) {
         this.hashFunctions.put(((Function)obj).name.toUpperCase(), obj);
      }

      return b;
   }

   public boolean add(Function func) {
      return this.add((Object)func);
   }

   public Function addFunc(String name, String title) {
      return this.addFunc(name, title, "", 0);
   }

   public Function addFunc(String name, String title, String description, int resultType) {
      Function func = new Function();
      func.name = name;
      func.title = title;
      func.description = description;
      func.resultType = resultType;
      return this.add(func) ? func : null;
   }

   public Object remove(int index) {
      Object obj = super.remove(index);
      if (obj != null) {
         this.hashFunctions.remove(((Function)obj).name.toUpperCase());
      }

      return obj;
   }
}
